# == Class: nagbot
#
# Nagbot IRC notification/commands bot.
#
# === Parameters
#
#
# === Examples
#
#  class { 'nagbot': }
#
# === Authors
#
# Sebastien Badia <seb@sebian.fr
#
# === Copyright
#
# Copyright 2014 Sebastien Badia, unless otherwise noted.
#
class nagbot(
  $irc_server       = 'irc.geeknode.net',
  $irc_chatnet      = 'geeknode',
  $irc_port         = '6697',
  $irc_ssl          = 'no',
  $irc_autoconnect  = 'no',
  $irc_autosendcmd  = '/^msg C nick IDENTIFY mybotpassword',
  $channel_name     = '#main_channel',
  $channel_chatnet  = 'geeknode',
  $channel_passwd   = 'password',
  $channel_autojoin = 'Yes',
  $nickname         = 'nagbot',
  $nagios_command   = '/var/lib/nagios3/rw/live',
  $fifo_remote_file = '/home/tc-14/var/nagios-fifo'

) {

  package { 'nagbot':
    ensure => installed,
  }

  file { '/etc/nagbot/config' :
    ensure  => present,
    owner   => 'nagbot',
    group   => 'nagbot',
    mode    => '0644',
    content => template('nagbot/config.erb'),
    require => Package['nagbot'],
  }

}
